﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
    
    public class Player extends FlxSprite
    {        
		private var _speed:Number;
		private var _frequency:Number;
		public var _health:int;
		private var _found:Boolean;
		private var _lastFrame:int;
		private var _blipArray:Array;
		private var _caughtThisBlip:Boolean;
		public var _runningHealth:int;
		public var _bHurt:Boolean;

		private static const tilesize:int = 64;
        public function Player(img:Class,speed:Number,starty:Number,health:Number,animation:Array,animationSpeed:Number):void
        {
            super(img, FlxG.width, starty, true, true, 24, 16);//Max speeds
			this.addAnimation("default", animation, animationSpeed);
			this.play("default");
			this.velocity.x = -speed;
			_speed = speed;
			_blipArray = animation;
			_lastFrame = 0;
			_caughtThisBlip = false;
			_health = health;
			_runningHealth = _health;
			_bHurt = false;
        }
		
        override public function update():void
        {		
			_bHurt = false;
			this.velocity.x = -_speed;
			var _enterBlip:Boolean = false;
			var _leaveBlip:Boolean = false;
			var _blip:Boolean = _blipArray[this._curFrame] == 1;
			if (_blipArray[_lastFrame] == 1 && _blipArray[this._curFrame] == 0)
			{
				if (!_caughtThisBlip)
					_runningHealth = _health;
				_leaveBlip = true;
				_caughtThisBlip = false;
			}
			else if (_blipArray[this._curFrame] == 1)
			{
				_enterBlip = true;
				if (!_caughtThisBlip)
				{
					if (MenuState.bClick)
					{
						_bHurt=true;
						_caughtThisBlip = true;
						_runningHealth--;
						if (_runningHealth <= 0)
						{
							this.kill();
						}
						else
						{
							this.flicker(0.2);
						}
					}
				}
			}
			_lastFrame = this._curFrame;
			if (x < 0)
				MenuState.bDead = true;
            super.update();		

        }    
    }
}