﻿package com.Tutorial 
{
    import com.adamatomic.flixel.*;
	import flash.geom.Rectangle;
	import com.Tutorial.Mother;
	
	/**
	 * ...
	 * @author Stephen Lavelle
	 */
	public class WalkState extends FlxState
	{
	    [Embed(source = '../../data/levels/flat.txt', mimeType = "application/octet-stream")] private var MainRoom:Class;
        [Embed(source = '../../data/gfx/tiles.png')] public static var ImgTiles:Class;
				
        public static var lyrBG:FlxLayer;
		public static var lyrPlayer:FlxLayer;
		public static var lyrNPC:FlxLayer;
		public static var lyrHUD:FlxLayer;
		
		private var fading:Boolean;
		private var _descText1:FlxText;
		private var _descText2:FlxText;
		private var _descText3:FlxText;
		private var _descText4:FlxText;
		private var _intDescr:String;
		
		private var _overlapfound:Boolean;
		private var _caninteractwith:int;

		private var _map:FlxTilemap;
		
		private var _player:Player;
		private var _mother:Mother;
		private var _doctor:Doctor;
		private var _son:Son;
		
		private var _interactables:FlxArray;
		
		private var interactionstate:int;//0 normal, 1 menu, 2 talk
		
		public function WalkState() 
		{

			interactionstate = 0;
			
			lyrBG = new FlxLayer;
			lyrPlayer = new FlxLayer;
			lyrNPC = new FlxLayer;
			lyrHUD = new FlxLayer;		
			
			_interactables = new FlxArray;
			fading = false;
			_interactables.push(new Interactable(11,121,11,11,"comp"));
			_interactables.push(new Interactable(22,143,33,22,"bed"));
			_interactables.push(new Interactable(143,22,11,11,"hob"));
			_interactables.push(new Interactable(22,22,22,11,"books"));
			_interactables.push(new Interactable(22,66,11,22,"books"));
			_interactables.push(new Interactable(44,88,22,11,"books"));
			_interactables.push(new Interactable(121,143,11,11,"door"));

			_player = new Player(6*11, 7*11,"left");
			FlxG.follow(_player,10);
			lyrPlayer.add(_player);
			_player.update();
			lyrPlayer.update();
			
			_mother = new Mother(14 * 11, 30 * 11+5, _player, 0, onSonFound);
			_doctor = new Doctor(28 * 11, 9 * 11+5, _player, 0, onSonFound);
			_son = new Son(65 * 11, 35 * 11, _player, _mother, 0, onSonSee,onSonCatch);
			lyrNPC.add(_mother);
			lyrNPC.add(_doctor);
			lyrNPC.add(_son);

			_map = new FlxTilemap(new MainRoom , ImgTiles,19 );
			
			lyrBG.add(_map);
			
			_descText1 = new FlxText(4*11, 9*11, FlxG.width, 60, "I'm so light-headed,\nso tired, and confused.", 0xff9bd8d7,null,8,"center");
			_descText1.visible = true;
			lyrHUD.add(_descText1);
			
			_descText2 = new FlxText(10*10, 32*11, FlxG.width+20, 60, "please find my son!\n he went out to the woods,\nand hasn't come back", 0xff9bd8d7,null,8,"center");
			_descText2.visible = true;
			lyrHUD.add(_descText2);
			
			_descText3 = new FlxText(19*11, 11*11, FlxG.width+30, 60, "your fainting spells are\nworsening?\nsuch is the fate of all widows", 0xff9bd8d7,null,8,"center");
			_descText3.visible = true;
			lyrHUD.add(_descText3);
			
			_descText4 = new FlxText(60*11, 36*11, FlxG.width, 60, "I'm so horny!\nNobody understands me!\nI'm so horny!", 0xff9bd8d7,null,8,"center");
			_descText4.visible = true;
			lyrHUD.add(_descText4);
						
			this.add(lyrBG);
			this.add(lyrNPC);
			this.add(lyrPlayer);
			this.add(lyrHUD);
			
			FlxG.flash(0xff000000,1);

		}
		
		public function onStart():void
		{
			
		}
		
		public function onMotherSee():void
		{
			
		}
		
		public function onDoctorSee():void
		{
			
		}
		
		public function onSonFound():void
		{
		}
		
		public function onSonSee():void
		{
			
		}
		
		public function onSonCatch():void
		{
						FlxG.switchState(EndState);

		}
		
		override public function update():void
        {
			if (fading)
				return;
			super.update();
						
			_map.collide(_player);
			_map.collide(_son);
			_player.collide(_son);
			_mother.collide(_player);
			_doctor.collide(_player);
			_son.collide(_player);
			
		}
		
		public function nextState():void
		{
			FlxG.switchState(MenuState);
		}
		
		public function interactfound(npc:Interactable, p:Player):void
		{
			if (npc.s == "bed")
			{
				_intDescr = "You don't feel tired";
				_overlapfound = true;
				_caninteractwith = 1;
			}
			else if (npc.s == "comp")
			{
				_intDescr = "Hook up with someone online";
				_overlapfound = true;
				_caninteractwith = 2;
			}
			else if (npc.s == "hob")
			{
				_intDescr = "There's no food in the flat";
				_overlapfound = true;
				_caninteractwith = 3;
			}
			else if (npc.s == "books")
			{
				_intDescr = "You don't feel like reading";
				_overlapfound = true;
				_caninteractwith = 4;
			}
			else if (npc.s == "door")
			{
				_intDescr = "It's cold out";
				_overlapfound = true;
				_caninteractwith = 5;
			}
		}
		
	}

}